/*
    Copyright (C) HWPORT.COM
    All rights reserved.
    Author: JAEHYUK CHO <mailto:minzkn@minzkn.com>
*/

#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>

#include <ifaddrs.h>

int main(void);

int main(void)
{
   int s_check;
   struct ifaddrs *s_ifaddrs;
   const struct ifaddrs *s_ifaddrs_trace;

   (void)fprintf(stdout, "BEGIN TEST...\n");

   s_ifaddrs = (struct ifaddrs *)0;
   s_check = getifaddrs((struct ifaddrs **)(&s_ifaddrs));
   if(s_check == (-1)) {
       int s_errno;

       s_errno = errno;

       perror("getifaddrs");

       (void)printf("errno is %d\n", s_errno);
   }
   else {
       for(s_ifaddrs_trace = s_ifaddrs;s_ifaddrs_trace != ((struct ifaddrs *)0);s_ifaddrs_trace = s_ifaddrs_trace->ifa_next) {
           (void)printf(
               "interface name [%s] family=%u\n",
               s_ifaddrs_trace->ifa_name == ((char *)0) ? "NULL" : s_ifaddrs_trace->ifa_name,
               (s_ifaddrs_trace->ifa_addr == ((struct sockaddr *)0)) ? 0u : (unsigned int)s_ifaddrs_trace->ifa_addr->sa_family
           );
       }

       if(s_ifaddrs != ((struct ifaddrs *)0)) {
           freeifaddrs(s_ifaddrs);
       }
   }

   (void)fprintf(stdout, "END TEST...\n");

   return(EXIT_SUCCESS);
}

/* vim: set expandtab: */
/* End of source */
